src/Web/ViewModels/OrderViewModel.cs
using System;
using System.Collections.Generic;
using Microsoft.eShopWeb.ApplicationCore.Entities.OrderAggregate;

namespace Microsoft.eShopWeb.Web.ViewModels;

public class OrderViewModel
{
    private const string DEFAULT_STATUS = "Pending";

    public int OrderNumber { get; set; }
    public DateTimeOffset OrderDate { get; set; }
    public decimal Total { get; set; }
    public string Status => DEFAULT_STATUS;
    public Address ShippingAddress { get; set; }
    public List<OrderItemViewModel> OrderItems { get; set; } = new List<OrderItemViewModel>();
}

src/Web/Controllers/OrderController.cs
using MediatR;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.eShopWeb.Web.Features.MyOrders;
using Microsoft.eShopWeb.Web.Features.OrderDetails;

namespace Microsoft.eShopWeb.Web.Controllers;

[ApiExplorerSettings(IgnoreApi = true)]
[Authorize] // Controllers that mainly require Authorization still use Controller/View; other pages use Pages
[Route("[controller]/[action]")]
public class OrderController : Controller
{
    private readonly IMediator _mediator;

    public OrderController(IMediator mediator)
    {
        _mediator = mediator;
    }

    [HttpGet]
    public async Task<IActionResult> MyOrders()
    {
        var viewModel = await _mediator.Send(new GetMyOrders(User.Identity.Name));

        return View(viewModel);
    }

    [HttpGet("{orderId}")]
    public async Task<IActionResult> Detail(int orderId)
    {
        var viewModel = await _mediator.Send(new GetOrderDetails(User.Identity.Name, orderId));

        if (viewModel == null)
        {
            return BadRequest("No such order found for this user.");
        }

        return View(viewModel);
    }
}

src/Web/Views/Order/Detail.cshtml
@model OrderViewModel
@{
    ViewData["Title"] = "My Order History";
}
@{
    ViewData["Title"] = "Order Detail";
}

<div class="esh-orders-detail">
    <div class="container">
        <section class="esh-orders-detail-section">
            <article class="esh-orders-detail-titles row">
                <section class="esh-orders-detail-title col-xs-3">Order number</section>
                <section class="esh-orders-detail-title col-xs-3">Date</section>
                <section class="esh-orders-detail-title col-xs-2">Total</section>
                <section class="esh-orders-detail-title col-xs-3">Status</section>
            </article>

            <article class="esh-orders-detail-items row">
                <section class="esh-orders-detail-item col-xs-3">@Model.OrderNumber</section>
                <section class="esh-orders-detail-item col-xs-3">@Model.OrderDate</section>
                <section class="esh-orders-detail-item col-xs-2">$@Model.Total.ToString("N2")</section>
                <section class="esh-orders-detail-item col-xs-3">@Model.Status</section>
            </article>
        </section>

        <section class="esh-orders-detail-section">
            <article class="esh-orders-detail-titles row">
                <section class="esh-orders-detail-title col-xs-12">Shipping Address</section>
            </article>

            <article class="esh-orders-detail-items row">
                <section class="esh-orders-detail-item col-xs-12">@Model.ShippingAddress.Street</section>
            </article>

            <article class="esh-orders-detail-items row">
                <section class="esh-orders-detail-item col-xs-12">@Model.ShippingAddress.City</section>
            </article>

            <article class="esh-orders-detail-items row">
                <section class="esh-orders-detail-item col-xs-12">@Model.ShippingAddress.Country</section>
            </article>
        </section>

        <section class="esh-orders-detail-section">
            <article class="esh-orders-detail-titles row">
                <section class="esh-orders-detail-title col-xs-12">ORDER DETAILS</section>
            </article>

            @for (int i = 0; i < Model.OrderItems.Count; i++)
            {
                var item = Model.OrderItems[i];
                <article class="esh-orders-detail-items esh-orders-detail-items--border row">
                    <section class="esh-orders-detail-item col-md-4 hidden-md-down">
                        <img class="esh-orders-detail-image" src="@item.PictureUrl">
                    </section>
                    <section class="esh-orders-detail-item esh-orders-detail-item--middle col-xs-3">@item.ProductName</section>
                    <section class="esh-orders-detail-item esh-orders-detail-item--middle col-xs-1">$ @item.UnitPrice.ToString("N2")</section>
                    <section class="esh-orders-detail-item esh-orders-detail-item--middle col-xs-1">@item.Units</section>
                    <section class="esh-orders-detail-item esh-orders-detail-item--middle col-xs-2">$ @Math.Round(item.Units * item.UnitPrice, 2).ToString("N2")</section>
                </article>
            }
        </section>

        <section class="esh-orders-detail-section esh-orders-detail-section--right">
            <article class="esh-orders-detail-titles esh-basket-titles--clean row">
                <section class="esh-orders-detail-title col-xs-9"></section>
                <section class="esh-orders-detail-title col-xs-2">TOTAL</section>
            </article>

            <article class="esh-orders-detail-items row">
                <section class="esh-orders-detail-item col-xs-9"></section>
                <section class="esh-orders-detail-item esh-orders-detail-item--mark col-xs-2">$ @Model.Total.ToString("N2")</section>
            </article>
        </section>
    </div>
</div>

src/Web/Views/Order/MyOrders.cshtml
@model IEnumerable<OrderViewModel>
@{
    ViewData["Title"] = "My Order History";
}

<div class="esh-orders">
    <div class="container">
        <h1>@ViewData["Title"]</h1>
        <article class="esh-orders-titles row">
            <section class="esh-orders-title col-xs-2">Order number</section>
            <section class="esh-orders-title col-xs-4">Date</section>
            <section class="esh-orders-title col-xs-2">Total</section>
            <section class="esh-orders-title col-xs-2">Status</section>
            <section class="esh-orders-title col-xs-2"></section>
        </article>
        @if (Model != null && Model.Any())
        {
            @foreach (var item in Model)
            {
                <article class="esh-orders-items row">
                    <section class="esh-orders-item col-xs-2">@Html.DisplayFor(modelItem => item.OrderNumber)</section>
                    <section class="esh-orders-item col-xs-4">@Html.DisplayFor(modelItem => item.OrderDate)</section>
                    <section class="esh-orders-item col-xs-2">$ @Html.DisplayFor(modelItem => item.Total)</section>
                    <section class="esh-orders-item col-xs-2">@Html.DisplayFor(modelItem => item.Status)</section>
                    <section class="esh-orders-item col-xs-1">
                        <a class="esh-orders-link" asp-controller="Order" asp-action="Detail" asp-route-orderId="@item.OrderNumber">Detail</a>
                    </section>
                    <section class="esh-orders-item col-xs-1">
                        @if (item.Status.ToLower() == "submitted")
                    {
                            <a class="esh-orders-link" asp-controller="Order" asp-action="cancel" asp-route-orderId="@item.OrderNumber">Cancel</a>
                        }
                    </section>
                </article>
            }
        }
    </div>
</div>